/*
 * register.h
 *
 *  Created on: 17 avr. 2023
 *      Author: sylvain
 */

#ifndef INC_REGISTER_H_
#define INC_REGISTER_H_

/* Includes ------------------------------------------------------------------*/
#include "stm32l0xx_ll_adc.h"
#include "stm32l0xx_ll_i2c.h"
#include "stm32l0xx_ll_crs.h"
#include "stm32l0xx_ll_rcc.h"
#include "stm32l0xx_ll_bus.h"
#include "stm32l0xx_ll_system.h"
#include "stm32l0xx_ll_exti.h"
#include "stm32l0xx_ll_cortex.h"
#include "stm32l0xx_ll_utils.h"
#include "stm32l0xx_ll_pwr.h"
#include "stm32l0xx_ll_dma.h"
#include "stm32l0xx_ll_spi.h"
#include "stm32l0xx_ll_tim.h"
#include "stm32l0xx_ll_usart.h"
#include "stm32l0xx_ll_gpio.h"

#include "main.h"
#include "stdbool.h"

/* Inputs ---------------------------------------------------------------------*/
#define mREG_ADC_TEMP_Pin LL_GPIO_PIN_0
#define mREG_ADC_TEMP_GPIO_Port GPIOA
#define mREG_VCP_TX_Pin LL_GPIO_PIN_2
#define mREG_VCP_TX_GPIO_Port GPIOA
#define mREG_ENC2_Pin LL_GPIO_PIN_3
#define mREG_ENC2_GPIO_Port GPIOA
#define mREG_ENC2_EXTI_IRQn EXTI2_3_IRQn
#define mREG_ENC1_Pin LL_GPIO_PIN_0
#define mREG_ENC1_GPIO_Port GPIOB
#define mREG_ENC1_EXTI_IRQn EXTI0_1_IRQn
#define mREG_LED_Pin LL_GPIO_PIN_1
#define mREG_LED_GPIO_Port GPIOB
#define mREG_PWM_HEATER_Pin LL_GPIO_PIN_8
#define mREG_PWM_HEATER_GPIO_Port GPIOA
#define mREG_ENC_SW_Pin LL_GPIO_PIN_9
#define mREG_ENC_SW_GPIO_Port GPIOA
#define mREG_DISPLAY_K3_Pin LL_GPIO_PIN_11
#define mREG_DISPLAY_K3_GPIO_Port GPIOA
#define mREG_STANDBY_SW_Pin LL_GPIO_PIN_12
#define mREG_STANDBY_SW_GPIO_Port GPIOA
#define mREG_TMS_Pin LL_GPIO_PIN_13
#define mREG_TMS_GPIO_Port GPIOA
#define mREG_mREG_TCK_Pin LL_GPIO_PIN_14
#define mREG_TCK_GPIO_Port GPIOA
#define mREG_VCP_RX_Pin LL_GPIO_PIN_15
#define mREG_VCP_RX_GPIO_Port GPIOA
#define mREG_LED_BLUE_Pin LL_GPIO_PIN_3
#define mREG_LED_BLUE_GPIO_Port GPIOB
#define mREG_DISPLAY_LATCH_Pin LL_GPIO_PIN_4
#define mREG_DISPLAY_LATCH_GPIO_Port GPIOB
#define mREG_DISPLAY_K1_Pin LL_GPIO_PIN_6
#define mREG_DISPLAY_K1_GPIO_Port GPIOB
#define mREG_DISPLAY_K2_Pin LL_GPIO_PIN_7
#define mREG_DISPLAY_K2_GPIO_Port GPIOB

#define mREGInputsENC1ActiveState    	(true)
#define mREGInputsENC1GetState()     	(bool)(LL_GPIO_IsInputPinSet(mREG_ENC1_GPIO_Port, mREG_ENC1_Pin) == mREGInputsENC1ActiveState)

#define mREGInputsENC2ActiveState    	(true)
#define mREGInputsENC2GetState()     	(bool)(LL_GPIO_IsInputPinSet(mREG_ENC2_GPIO_Port, mREG_ENC2_Pin) == mREGInputsENC2ActiveState)

#define mREGInputsSWActiveState      	(false)
#define mREGInputsSWGetState()			(bool)(LL_GPIO_IsInputPinSet(mREG_ENC_SW_GPIO_Port, mREG_ENC_SW_Pin) == mREGInputsENC2ActiveState)

/* External interrupts --------------------------------------------------------*/
// ENC1 : EXTI0
#define mREGInputsENC1ExtiEnableIT() 	(LL_EXTI_EnableIT_0_31(LL_EXTI_LINE_0))

// ENC2 : EXTI3
#define mREGInputsENC2ExtiEnableIT() 	(LL_EXTI_EnableIT_0_31(LL_EXTI_LINE_3))

#endif /* INC_REGISTER_H_ */
