/*
 * display.c
 *
 *  Created on: 21 avr. 2023
 *      Author: Flax
 */

// ==============
// Local includes
// ==============
#include "display.h"

// ===============
// Local constants
// ===============
#define cDISPMaxDigit		(3U)
#define cDISPValueMax		(999U)

// Division-less decade separation : https://www.baghli.com/hex2dec.php
#define cDISPDecadeSeparation100Num		((uint32_t)5243) // m
#define cDISPDecadeSeparation100Denom	((uint32_t)65536*8) // 2^s * 2^W
#define cDISPDecadeSeparation10Num		((uint32_t)52429) // m
#define cDISPDecadeSeparation10Denom	((uint32_t)65536*8) // 2^s * 2^W

// ===============
// Local variables
// ===============

// ===========================
// Local functions prototypes
// ===========================

// ===========================
// Local functions definitions
// ===========================

// ============================
// Shared functions definitions
// ============================
void DISPInit (void)
{

}

void DISPStart (void)
{

}

void DISPStop (void)
{

}

bool DISPSetDisplayDigit (uint8_t digit_u8, char digit_value_u8)
{
	bool ret_B = false;
	if (digit_u8 < (uint8_t)cDISPMaxDigit)
	{
		ret_B = true;
	}
	return (ret_B);
}

char DISPNumberToChar (uint8_t number_u8)
{
	char ret_C;

	return ret_C;
}

bool DISPValueToDigits (uint16_t value_u16, uint8_t* digits_U8A[])
{
	bool ret_B = false;
	uint16_t value_local_u16;

	// Division-less decade separation : https://www.baghli.com/hex2dec.php
	if (value_u16 <= cDISPValueMax)
	{
		ret_B = true;
		value_local_u16 = value_u16;

		// Check for 1st digit
		if (value_local_u16 > 99U)
		{
			// Divide by 100
			digits_U8A[0U] = (uint8_t)((cDISPDecadeSeparation100Num * (uint32_t)value_local_u16) / cDISPDecadeSeparation100Denom);
			value_local_u16 = value_local_u16 - ((uint16_t)(digits_U8A[0U]) * 100U); // Remove 1st digit
		}
		else
		{
			digits_U8A[0U] = 0U;
		}

		// Check for 2nd digit
		if (value_local_u16 > 9U)
		{
			// Divide by 10
			digits_U8A[1U] = (uint8_t)((cDISPDecadeSeparation10Num * (uint32_t)value_local_u16) / cDISPDecadeSeparation10Denom);
			value_local_u16 = value_local_u16 - ((uint16_t)(digits_U8A[1U]) * 10U); // Remove 2nd digit
		}
		else
		{
			digits_U8A[1U] = 0U;
		}

		// Check for 3nd digit
		digits_U8A[2U] = (uint8_t)value_local_u16;
	}

	return ret_B;
}


